Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3597)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3600)
@@ -1793,699 +1820,709 @@
 !> analogue to parameters u_profile, v_profile and uv_heights)
 !------------------------------------------------------------------------------!
-    SUBROUTINE chem_init_profiles              !< SUBROUTINE is called from chem_init in case of 
-                                               !< TRIM( initializing_actions ) /= 'read_restart_data'
-                                               !< We still need to see what has to be done in case of restart run
-       USE chem_modules
-
-       IMPLICIT NONE
-
-   !-- Local variables
-       INTEGER ::  lsp        !< running index for number of species in derived data type species_def
-       INTEGER ::  lsp_usr     !< running index for number of species (user defined)  in cs_names, cs_profiles etc
-       INTEGER ::  lpr_lev    !< running index for profile level for each chem spcs. 
-       INTEGER ::  npr_lev    !< the next available profile lev
-
-!-----------------
-!-- Parameter "cs_profile" and "cs_heights" are used to prescribe user defined initial profiles
-!-- and heights. If parameter "cs_profile" is not prescribed then initial surface values
-!-- "cs_surface" are used as constant initial profiles for each species. If "cs_profile" and
-!-- "cs_heights" are prescribed, their values will!override the constant profile given by
-!-- "cs_surface".
-! 
-       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN 
-          lsp_usr = 1
-          DO  WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )   !'novalue' is the default
-             DO  lsp = 1, nspec                                !
-!--             create initial profile (conc_pr_init) for each chemical species
-                IF ( TRIM( chem_species(lsp)%name ) == TRIM( cs_name(lsp_usr) ) )  THEN   !
-                   IF ( cs_profile(lsp_usr,1) == 9999999.9_wp ) THEN
-!--                set a vertically constant profile based on the surface conc (cs_surface(lsp_usr)) of each species
-                      DO lpr_lev = 0, nzt+1
-                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_surface(lsp_usr)
-                      ENDDO
-                   ELSE
-                      IF ( cs_heights(1,1) /= 0.0_wp )  THEN
-                         message_string = 'The surface value of cs_heights must be 0.0'
-                         CALL message( 'chem_check_parameters', 'CM0434', 1, 2, 0, 6, 0 )
+ SUBROUTINE chem_init_profiles              !< SUBROUTINE is called from chem_init in case of 
+   !< TRIM( initializing_actions ) /= 'read_restart_data'
+   !< We still need to see what has to be done in case of restart run
+    USE chem_modules
+
+    IMPLICIT NONE
+
+    !-- Local variables
+    INTEGER ::  lsp        !< running index for number of species in derived data type species_def
+    INTEGER ::  lsp_usr     !< running index for number of species (user defined)  in cs_names, cs_profiles etc
+    INTEGER ::  lpr_lev    !< running index for profile level for each chem spcs. 
+    INTEGER ::  npr_lev    !< the next available profile lev
+
+    !-----------------
+    !-- Parameter "cs_profile" and "cs_heights" are used to prescribe user defined initial profiles
+    !-- and heights. If parameter "cs_profile" is not prescribed then initial surface values
+    !-- "cs_surface" are used as constant initial profiles for each species. If "cs_profile" and
+    !-- "cs_heights" are prescribed, their values will!override the constant profile given by
+    !-- "cs_surface".
+    ! 
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN 
+       lsp_usr = 1
+       DO  WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )   !'novalue' is the default
+          DO  lsp = 1, nspec                                !
+             !-- create initial profile (conc_pr_init) for each chemical species
+             IF ( TRIM( chem_species(lsp)%name ) == TRIM( cs_name(lsp_usr) ) )  THEN   !
+                IF ( cs_profile(lsp_usr,1) == 9999999.9_wp ) THEN
+                   !-- set a vertically constant profile based on the surface conc (cs_surface(lsp_usr)) of each species
+                   DO lpr_lev = 0, nzt+1
+                      chem_species(lsp)%conc_pr_init(lpr_lev) = cs_surface(lsp_usr)
+                   ENDDO
+                ELSE
+                   IF ( cs_heights(1,1) /= 0.0_wp )  THEN
+                      message_string = 'The surface value of cs_heights must be 0.0'
+                      CALL message( 'chem_check_parameters', 'CM0434', 1, 2, 0, 6, 0 )
+                   ENDIF
+
+                   use_prescribed_profile_data = .TRUE.
+
+                   npr_lev = 1
+                   !                     chem_species(lsp)%conc_pr_init(0) = 0.0_wp
+                   DO  lpr_lev = 1, nz+1
+                      IF ( npr_lev < 100 )  THEN
+                         DO  WHILE ( cs_heights(lsp_usr, npr_lev+1) <= zu(lpr_lev) )
+                            npr_lev = npr_lev + 1
+                            IF ( npr_lev == 100 )  THEN
+                               message_string = 'number of chem spcs exceeding the limit'
+                               CALL message( 'chem_check_parameters', 'CM0435', 1, 2, 0, 6, 0 )               
+                               EXIT
+                            ENDIF
+                         ENDDO
                       ENDIF
-     
-                      use_prescribed_profile_data = .TRUE.
-    
-                      npr_lev = 1
-!                     chem_species(lsp)%conc_pr_init(0) = 0.0_wp
-                      DO  lpr_lev = 1, nz+1
-                         IF ( npr_lev < 100 )  THEN
-                            DO  WHILE ( cs_heights(lsp_usr, npr_lev+1) <= zu(lpr_lev) )
-                               npr_lev = npr_lev + 1
-                               IF ( npr_lev == 100 )  THEN
-                                   message_string = 'number of chem spcs exceeding the limit'
-                                   CALL message( 'chem_check_parameters', 'CM0435', 1, 2, 0, 6, 0 )               
-                                   EXIT
-                               ENDIF
-                            ENDDO
-                         ENDIF
-                         IF ( npr_lev < 100  .AND.  cs_heights(lsp_usr, npr_lev + 1) /= 9999999.9_wp )  THEN
-                            chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev) +                          &
-                                                    ( zu(lpr_lev) - cs_heights(lsp_usr, npr_lev) ) /                          &
-                                                    ( cs_heights(lsp_usr, (npr_lev + 1)) - cs_heights(lsp_usr, npr_lev ) ) *  &
-                                                    ( cs_profile(lsp_usr, (npr_lev + 1)) - cs_profile(lsp_usr, npr_lev ) )
-                         ELSE
-                               chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev)
-                         ENDIF
-                      ENDDO
-                   ENDIF
-!-- If a profile is prescribed explicity using cs_profiles and cs_heights, then  
-!-- chem_species(lsp)%conc_pr_init is populated with the specific "lsp" based
-!-- on the cs_profiles(lsp_usr,:)  and cs_heights(lsp_usr,:). 
+                      IF ( npr_lev < 100  .AND.  cs_heights(lsp_usr, npr_lev + 1) /= 9999999.9_wp )  THEN
+                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev) +       &
+                              ( zu(lpr_lev) - cs_heights(lsp_usr, npr_lev) ) /                          &
+                              ( cs_heights(lsp_usr, (npr_lev + 1)) - cs_heights(lsp_usr, npr_lev ) ) *  &
+                              ( cs_profile(lsp_usr, (npr_lev + 1)) - cs_profile(lsp_usr, npr_lev ) )
+                      ELSE
+                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev)
+                      ENDIF
+                   ENDDO
                 ENDIF
+                !-- If a profile is prescribed explicity using cs_profiles and cs_heights, then  
+                !-- chem_species(lsp)%conc_pr_init is populated with the specific "lsp" based
+                !-- on the cs_profiles(lsp_usr,:)  and cs_heights(lsp_usr,:). 
+             ENDIF
+          ENDDO
+          lsp_usr = lsp_usr + 1
+       ENDDO
+    ENDIF
+
+ END SUBROUTINE chem_init_profiles
+ !
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine to integrate chemical species in the given chemical mechanism
+ !------------------------------------------------------------------------------!
+
+ SUBROUTINE chem_integrate_ij( i, j )
+
+    USE cpulog,                                                              &
+         ONLY:  cpu_log, log_point
+    USE statistics,                                                          &
+         ONLY:  weight_pres
+    USE control_parameters,                                                 &
+         ONLY:  dt_3d, intermediate_timestep_count, simulated_time
+
+    IMPLICIT NONE
+    INTEGER,INTENT(IN)       :: i
+    INTEGER,INTENT(IN)       :: j
+
+    !--   local variables
+    INTEGER(iwp) ::  lsp                                                     !< running index for chem spcs.
+    INTEGER(iwp) ::  lph                                                     !< running index for photolysis frequencies
+    INTEGER      ::  k
+    INTEGER      ::  m
+    INTEGER      ::  istatf
+    INTEGER, DIMENSION(20)    :: istatus
+    REAL(kind=wp), DIMENSION(nzb+1:nzt,nspec)                :: tmp_conc
+    REAL(kind=wp), DIMENSION(nzb+1:nzt)                      :: tmp_temp
+    REAL(kind=wp), DIMENSION(nzb+1:nzt)                      :: tmp_qvap
+    REAL(kind=wp), DIMENSION(nzb+1:nzt,nphot)                :: tmp_phot
+    REAL(kind=wp), DIMENSION(nzb+1:nzt)                      :: tmp_fact
+    REAL(kind=wp), DIMENSION(nzb+1:nzt)                      :: tmp_fact_i    !< conversion factor between 
+                                                                              !<    molecules cm^{-3} and ppm
+
+    INTEGER,DIMENSION(nzb+1:nzt)                            :: nacc          !< Number of accepted steps
+    INTEGER,DIMENSION(nzb+1:nzt)                            :: nrej          !< Number of rejected steps
+
+    REAL(wp)                         ::  conv                                !< conversion factor
+    REAL(wp), PARAMETER              ::  ppm2fr  = 1.0e-6_wp                 !< Conversion factor ppm to fraction
+!    REAL(wp), PARAMETER              ::  xm_air  = 28.96_wp                  !< Mole mass of dry air
+!    REAL(wp), PARAMETER              ::  xm_h2o  = 18.01528_wp               !< Mole mass of water vapor
+    REAL(wp), PARAMETER              ::  pref_i  = 1._wp / 100000.0_wp       !< inverse reference pressure (1/Pa)
+    REAL(wp), PARAMETER              ::  t_std   = 273.15_wp                 !< standard pressure (Pa)
+    REAL(wp), PARAMETER              ::  p_std   = 101325.0_wp               !< standard pressure (Pa)
+    REAL(wp), PARAMETER              ::  vmolcm  = 22.414e3_wp               !< Mole volume (22.414 l) in cm^{-3}
+    REAL(wp), PARAMETER              ::  xna     = 6.022e23_wp               !< Avogadro number (molecules/mol)
+
+    REAL(wp),DIMENSION(size(rcntrl)) :: rcntrl_local
+
+
+    REAL(kind=wp)  :: dt_chem                                             
+
+    CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'start' )
+    !<     set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
+    IF (chem_gasphase_on) THEN
+       nacc = 0
+       nrej = 0
+
+       tmp_temp(:) = pt(nzb+1:nzt,j,i) * exner(nzb+1:nzt)
+       !
+       !--       ppm to molecules/cm**3
+       !--       tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )  
+       conv = ppm2fr * xna / vmolcm
+       tmp_fact(:) = conv * t_std * hyp(nzb+1:nzt) / (tmp_temp(:) * p_std)
+       tmp_fact_i = 1.0_wp/tmp_fact
+
+       IF ( humidity ) THEN
+          IF ( bulk_cloud_model )  THEN
+             tmp_qvap(:) = ( q(nzb+1:nzt,j,i) - ql(nzb+1:nzt,j,i) ) * xm_air/xm_h2o * tmp_fact(:)
+          ELSE
+             tmp_qvap(:) = q(nzb+1:nzt,j,i) * xm_air/xm_h2o * tmp_fact(:)
+          ENDIF
+       ELSE
+          tmp_qvap(:) = 0.01 * tmp_fact(:)                          !< Constant value for q if water vapor is not computed
+       ENDIF
+
+       DO lsp = 1,nspec
+          tmp_conc(:,lsp) = chem_species(lsp)%conc(nzb+1:nzt,j,i) * tmp_fact(:) 
+       ENDDO
+
+       DO lph = 1,nphot
+          tmp_phot(:,lph) = phot_frequen(lph)%freq(nzb+1:nzt,j,i)               
+       ENDDO
+       !
+       !--   todo: remove (kanani)
+       !           IF(myid == 0 .AND. chem_debug0 ) THEN
+       !              IF (i == 10 .AND. j == 10) WRITE(0,*) 'begin chemics step ',dt_3d
+       !           ENDIF
+
+       !--       Compute length of time step
+       IF ( call_chem_at_all_substeps )  THEN
+          dt_chem = dt_3d * weight_pres(intermediate_timestep_count)
+       ELSE
+          dt_chem = dt_3d
+       ENDIF
+
+       cs_time_step = dt_chem
+
+       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'start' )
+
+       IF(maxval(rcntrl) > 0.0)   THEN    ! Only if rcntrl is set
+          IF( simulated_time <= 2*dt_3d)  THEN
+             rcntrl_local = 0
+             !
+             !--   todo: remove (kanani)
+             !                  WRITE(9,'(a,2f10.3)') 'USE Default rcntrl in the first steps ',simulated_time,dt_3d
+          ELSE
+             rcntrl_local = rcntrl
+          ENDIF
+       ELSE
+          rcntrl_local = 0
+       END IF
+
+       CALL chem_gasphase_integrate ( dt_chem, tmp_conc, tmp_temp, tmp_qvap, tmp_fact, tmp_phot, &
+            icntrl_i = icntrl, rcntrl_i = rcntrl_local, xnacc = nacc, xnrej = nrej, istatus=istatus )
+
+       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'stop' )
+
+       DO lsp = 1,nspec
+          chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)
+       ENDDO
+
+
+    ENDIF
+    CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'stop' )
+
+    RETURN
+ END SUBROUTINE chem_integrate_ij
+ !
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine defining parin for &chemistry_parameters for chemistry model
+ !------------------------------------------------------------------------------!
+ SUBROUTINE chem_parin
+
+    USE chem_modules
+    USE control_parameters
+
+    USE kinds
+    USE pegrid
+    USE statistics
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=80) ::  line                        !< dummy string that contains the current line of the parameter file
+    CHARACTER (LEN=3)  ::  cs_prefix 
+
+    REAL(wp), DIMENSION(nmaxfixsteps) ::   my_steps    !< List of fixed timesteps   my_step(1) = 0.0 automatic stepping
+    INTEGER(iwp) ::  i                                 !< 
+    INTEGER(iwp) ::  j                                 !< 
+    INTEGER(iwp) ::  max_pr_cs_tmp                     !< 
+
+
+    NAMELIST /chemistry_parameters/  bc_cs_b,                          &
+         bc_cs_t,                          &
+         call_chem_at_all_substeps,        &
+         chem_debug0,                      &
+         chem_debug1,                      &
+         chem_debug2,                      &
+         chem_gasphase_on,                 &
+         cs_heights,                       &
+         cs_name,                          &
+         cs_profile,                       &
+         cs_surface,                       &
+         decycle_chem_lr,                  &
+         decycle_chem_ns,                  &            
+         decycle_method,                   &
+         do_depo,                          &
+         emiss_factor_main,                &
+         emiss_factor_side,                &                      
+         icntrl,                           &
+         main_street_id,                   &
+         max_street_id,                    &
+         my_steps,                         &
+         nest_chemistry,                   &
+         rcntrl,                           &
+         side_street_id,                   &
+         photolysis_scheme,                &
+         wall_csflux,                      &
+         cs_vertical_gradient,             &
+         top_csflux,                       & 
+         surface_csflux,                   &
+         surface_csflux_name,              &
+         cs_surface_initial_change,        &
+         cs_vertical_gradient_level,       &
+         !                                       namelist parameters for emissions
+         mode_emis,                        &
+         time_fac_type,                    &
+         daytype_mdh,                      &
+         do_emis                              
+
+    !-- analogue to chem_names(nspj) we could invent chem_surfaceflux(nspj) and chem_topflux(nspj)
+    !-- so this way we could prescribe a specific flux value for each species
+    !>  chemistry_parameters for initial profiles
+    !>  cs_names = 'O3', 'NO2', 'NO', ...   to set initial profiles)
+    !>  cs_heights(1,:) = 0.0, 100.0, 500.0, 2000.0, .... (height levels where concs will be prescribed for O3)
+    !>  cs_heights(2,:) = 0.0, 200.0, 400.0, 1000.0, .... (same for NO2 etc.) 
+    !>  cs_profiles(1,:) = 10.0, 20.0, 20.0, 30.0, .....  (chem spcs conc at height lvls chem_heights(1,:)) etc.
+    !>  If the respective concentration profile should be constant with height, then use "cs_surface( number of spcs)"
+    !>  then write these cs_surface values to chem_species(lsp)%conc_pr_init(:)
+
+    !
+    !--   Read chem namelist   
+
+    INTEGER             :: ier
+    CHARACTER(LEN=64)   :: text
+    CHARACTER(LEN=8)    :: solver_type
+
+    icntrl    = 0
+    rcntrl    = 0.0_wp
+    my_steps  = 0.0_wp
+    photolysis_scheme = 'simple'
+    atol = 1.0_wp
+    rtol = 0.01_wp
+    !
+    !--   Try to find chemistry package
+    REWIND ( 11 )
+    line = ' '
+    DO   WHILE ( INDEX( line, '&chemistry_parameters' ) == 0 )
+       READ ( 11, '(A)', END=20 )  line
+    ENDDO
+    BACKSPACE ( 11 )
+    !
+    !--   Read chemistry namelist
+    READ ( 11, chemistry_parameters, ERR = 10, END = 20 )      
+    !
+    !--   Enable chemistry model
+    air_chemistry = .TRUE.                    
+    GOTO 20
+
+ 10 BACKSPACE( 11 )
+    READ( 11 , '(A)') line
+    CALL parin_fail_message( 'chemistry_parameters', line )
+
+ 20 CONTINUE
+
+    !
+    !--    check for  emission mode for chem species
+    IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT' ) .AND. ( mode_emis /= 'PRE-PROCESSED'  ) )  THEN
+       message_string = 'Incorrect mode_emiss  option select. Please check spelling'
+       CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+    ENDIF
+
+    t_steps = my_steps          
+
+    !--    Determine the number of user-defined profiles and append them to the
+    !--    standard data output (data_output_pr)
+    max_pr_cs_tmp = 0 
+    i = 1
+
+    DO  WHILE ( data_output_pr(i)  /= ' '  .AND.  i <= 100 )
+       IF ( TRIM( data_output_pr(i)(1:3)) == 'kc_' ) THEN
+          max_pr_cs_tmp = max_pr_cs_tmp+1
+       ENDIF
+       i = i +1
+    ENDDO
+
+    IF ( max_pr_cs_tmp > 0 ) THEN
+       cs_pr_namelist_found = .TRUE.
+       max_pr_cs = max_pr_cs_tmp
+    ENDIF
+
+    !      Set Solver Type
+    IF(icntrl(3) == 0)   THEN
+       solver_type = 'rodas3'           !Default
+    ELSE IF(icntrl(3) == 1)   THEN
+       solver_type = 'ros2'
+    ELSE IF(icntrl(3) == 2)   THEN
+       solver_type = 'ros3'
+    ELSE IF(icntrl(3) == 3)   THEN
+       solver_type = 'ro4'
+    ELSE IF(icntrl(3) == 4)   THEN
+       solver_type = 'rodas3'
+    ELSE IF(icntrl(3) == 5)   THEN
+       solver_type = 'rodas4'
+    ELSE IF(icntrl(3) == 6)   THEN
+       solver_type = 'Rang3'
+    ELSE
+       message_string = 'illegal solver type'
+       CALL message( 'chem_parin', 'PA0506', 1, 2, 0, 6, 0 )
+    END IF
+
+    !
+    !--   todo: remove or replace by "CALL message" mechanism (kanani)
+    !       write(text,*) 'gas_phase chemistry: solver_type = ',TRIM(solver_type)
+    !kk    Has to be changed to right calling sequence
+    !kk       CALL location_message( TRIM(text), .FALSE. )
+    !        IF(myid == 0)   THEN
+    !           write(9,*) ' '
+    !           write(9,*) 'kpp setup '
+    !           write(9,*) ' '
+    !           write(9,*) '    gas_phase chemistry: solver_type = ',TRIM(solver_type)
+    !           write(9,*) ' '
+    !           write(9,*) '    Hstart  = ',rcntrl(3)
+    !           write(9,*) '    FacMin  = ',rcntrl(4)
+    !           write(9,*) '    FacMax  = ',rcntrl(5)
+    !           write(9,*) ' '
+    !           IF(vl_dim > 1)    THEN
+    !              write(9,*) '    Vector mode                   vektor length = ',vl_dim
+    !           ELSE
+    !              write(9,*) '    Scalar mode'
+    !           ENDIF
+    !           write(9,*) ' '
+    !        END IF
+
+    RETURN
+
+ END SUBROUTINE chem_parin
+
+ !
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine calculating prognostic equations for chemical species 
+ !> (vector-optimized).
+ !> Routine is called separately for each chemical species over a loop from
+ !> prognostic_equations.
+ !------------------------------------------------------------------------------!
+ SUBROUTINE chem_prognostic_equations( cs_scalar_p, cs_scalar, tcs_scalar_m,   &
+      pr_init_cs, ilsp )
+
+    USE advec_s_pw_mod,                                                        &
+         ONLY:  advec_s_pw
+    USE advec_s_up_mod,                                                        &
+         ONLY:  advec_s_up
+    USE advec_ws,                                                              &
+         ONLY:  advec_s_ws 
+    USE diffusion_s_mod,                                                       &
+         ONLY:  diffusion_s
+    USE indices,                                                               &
+         ONLY:  nxl, nxr, nyn, nys, wall_flags_0
+    USE pegrid
+    USE surface_mod,                                                           &
+         ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
+         surf_usm_v
+
+    IMPLICIT NONE
+
+    INTEGER ::  i   !< running index
+    INTEGER ::  j   !< running index
+    INTEGER ::  k   !< running index
+
+    INTEGER(iwp),INTENT(IN) ::  ilsp          !<
+
+    REAL(wp), DIMENSION(0:nz+1) ::  pr_init_cs   !<
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar      !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar_p    !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tcs_scalar_m   !<
+
+
+    !
+    !-- Tendency terms for chemical species
+    tend = 0.0_wp
+    !    
+    !-- Advection terms
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( ws_scheme_sca )  THEN
+          CALL advec_s_ws( cs_scalar, 'kc' )
+       ELSE
+          CALL advec_s_pw( cs_scalar )
+       ENDIF
+    ELSE
+       CALL advec_s_up( cs_scalar )
+    ENDIF
+    !
+    !-- Diffusion terms  (the last three arguments are zero)
+    CALL diffusion_s( cs_scalar,                                               &
+         surf_def_h(0)%cssws(ilsp,:),                             &
+         surf_def_h(1)%cssws(ilsp,:),                             &
+         surf_def_h(2)%cssws(ilsp,:),                             &
+         surf_lsm_h%cssws(ilsp,:),                                &
+         surf_usm_h%cssws(ilsp,:),                                &
+         surf_def_v(0)%cssws(ilsp,:),                             &
+         surf_def_v(1)%cssws(ilsp,:),                             &
+         surf_def_v(2)%cssws(ilsp,:),                             &
+         surf_def_v(3)%cssws(ilsp,:),                             &
+         surf_lsm_v(0)%cssws(ilsp,:),                             &
+         surf_lsm_v(1)%cssws(ilsp,:),                             &
+         surf_lsm_v(2)%cssws(ilsp,:),                             &
+         surf_lsm_v(3)%cssws(ilsp,:),                             &
+         surf_usm_v(0)%cssws(ilsp,:),                             &
+         surf_usm_v(1)%cssws(ilsp,:),                             &
+         surf_usm_v(2)%cssws(ilsp,:),                             &
+         surf_usm_v(3)%cssws(ilsp,:) )
+    !    
+    !-- Prognostic equation for chemical species
+    DO  i = nxl, nxr
+       DO  j = nys, nyn    
+          DO  k = nzb+1, nzt
+             cs_scalar_p(k,j,i) =   cs_scalar(k,j,i)                           &
+                  + ( dt_3d  *                                 &
+                  (   tsc(2) * tend(k,j,i)                 &
+                  + tsc(3) * tcs_scalar_m(k,j,i)         &
+                  )                                        & 
+                  - tsc(5) * rdf_sc(k)                       &
+                  * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
+                  )                                          &
+                  * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )       
+
+             IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+    !
+    !-- Calculate tendencies for the next Runge-Kutta step
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( intermediate_timestep_count == 1 )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn   
+                DO  k = nzb+1, nzt
+                   tcs_scalar_m(k,j,i) = tend(k,j,i)
+                ENDDO
              ENDDO
-             lsp_usr = lsp_usr + 1
+          ENDDO
+       ELSEIF ( intermediate_timestep_count < &
+            intermediate_timestep_count_max )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt
+                   tcs_scalar_m(k,j,i) = - 9.5625_wp * tend(k,j,i)             &
+                        + 5.3125_wp * tcs_scalar_m(k,j,i)
+                ENDDO
+             ENDDO
           ENDDO
        ENDIF
-
-    END SUBROUTINE chem_init_profiles
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine to integrate chemical species in the given chemical mechanism
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE chem_integrate_ij (i, j)
-
-       USE cpulog,                                                              &
-          ONLY: cpu_log, log_point
-       USE statistics,                                                          &
-          ONLY:  weight_pres
-        USE control_parameters,                                                 &
-          ONLY:  dt_3d, intermediate_timestep_count,simulated_time
-
-       IMPLICIT   none
-       INTEGER,INTENT(IN)       :: i,j
-
- !--   local variables
-       INTEGER(iwp) ::  lsp                                                     !< running index for chem spcs.
-       INTEGER(iwp) ::  lph                                                     !< running index for photolysis frequencies
-       INTEGER                  :: k,m,istatf
-       INTEGER,DIMENSION(20)    :: istatus
-       REAL(kind=wp),DIMENSION(nzb+1:nzt,nspec)                :: tmp_conc
-       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_temp
-       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_qvap
-       REAL(kind=wp),DIMENSION(nzb+1:nzt,nphot)                :: tmp_phot
-       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_fact
-       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_fact_i    !< conversion factor between 
-                                                                                !<    molecules cm^{-3} and ppm
-
-       INTEGER,DIMENSION(nzb+1:nzt)                            :: nacc          !< Number of accepted steps
-       INTEGER,DIMENSION(nzb+1:nzt)                            :: nrej          !< Number of rejected steps
-
-       REAL(wp)                         ::  conv                                !< conversion factor
-       REAL(wp), PARAMETER              ::  ppm2fr  = 1.0e-6_wp                 !< Conversion factor ppm to fraction
-       REAL(wp), PARAMETER              ::  xm_air  = 28.96_wp                  !< Mole mass of dry air
-       REAL(wp), PARAMETER              ::  xm_h2o  = 18.01528_wp               !< Mole mass of water vapor
-       REAL(wp), PARAMETER              ::  pref_i  = 1._wp / 100000.0_wp       !< inverse reference pressure (1/Pa)
-       REAL(wp), PARAMETER              ::  t_std   = 273.15_wp                 !< standard pressure (Pa)
-       REAL(wp), PARAMETER              ::  p_std   = 101325.0_wp               !< standard pressure (Pa)
-       REAL(wp), PARAMETER              ::  vmolcm  = 22.414e3_wp               !< Mole volume (22.414 l) in cm^{-3}
-       REAL(wp), PARAMETER              ::  xna     = 6.022e23_wp               !< Avogadro number (molecules/mol)
-
-       REAL(wp),DIMENSION(size(rcntrl)) :: rcntrl_local
-
-
-       REAL(kind=wp)  :: dt_chem                                             
-
-       CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'start' )
-!<     set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
-       IF (chem_gasphase_on) THEN
-          nacc = 0
-          nrej = 0
-
-       tmp_temp(:) = pt(nzb+1:nzt,j,i) * exner(nzb+1:nzt)
-!         ppm to molecules/cm**3
-!         tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )  
-          conv = ppm2fr * xna / vmolcm
-          tmp_fact(:) = conv * t_std * hyp(nzb+1:nzt) / (tmp_temp(:) * p_std)
-          tmp_fact_i = 1.0_wp/tmp_fact
-
-          IF ( humidity ) THEN
-             IF ( bulk_cloud_model )  THEN
-                tmp_qvap(:) = ( q(nzb+1:nzt,j,i) - ql(nzb+1:nzt,j,i) ) * xm_air/xm_h2o * tmp_fact(:)
-             ELSE
-                tmp_qvap(:) = q(nzb+1:nzt,j,i) * xm_air/xm_h2o * tmp_fact(:)
-             ENDIF
-          ELSE
-             tmp_qvap(:) = 0.01 * tmp_fact(:)                          !< Constant value for q if water vapor is not computed
+    ENDIF
+
+ END SUBROUTINE chem_prognostic_equations
+
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine calculating prognostic equations for chemical species 
+ !> (cache-optimized).
+ !> Routine is called separately for each chemical species over a loop from
+ !> prognostic_equations.
+ !------------------------------------------------------------------------------!
+ SUBROUTINE chem_prognostic_equations_ij( cs_scalar_p, cs_scalar, tcs_scalar_m, pr_init_cs,     &
+      i, j, i_omp_start, tn, ilsp, flux_s_cs, diss_s_cs,                  &
+      flux_l_cs, diss_l_cs )
+    USE pegrid         
+    USE advec_ws,                                                                               &
+         ONLY:  advec_s_ws 
+    USE advec_s_pw_mod,                                                                         &
+         ONLY:  advec_s_pw
+    USE advec_s_up_mod,                                                                         &
+         ONLY:  advec_s_up
+    USE diffusion_s_mod,                                                                        &
+         ONLY:  diffusion_s
+    USE indices,                                                                                &
+         ONLY:  wall_flags_0
+    USE surface_mod,                                                                            &
+         ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+
+
+    IMPLICIT NONE
+
+    REAL(wp), DIMENSION(:,:,:), POINTER   :: cs_scalar_p, cs_scalar, tcs_scalar_m
+
+    INTEGER(iwp),INTENT(IN) :: i, j, i_omp_start, tn, ilsp
+    REAL(wp), DIMENSION(nzb+1:nzt, 0:threads_per_task-1)          :: flux_s_cs   !<
+    REAL(wp), DIMENSION(nzb+1:nzt, 0:threads_per_task-1)          :: diss_s_cs   !<
+    REAL(wp), DIMENSION(nzb+1:nzt, nys:nyn, 0:threads_per_task-1) :: flux_l_cs   !<
+    REAL(wp), DIMENSION(nzb+1:nzt, nys:nyn, 0:threads_per_task-1) :: diss_l_cs   !<
+    REAL(wp), DIMENSION(0:nz+1)                                 :: pr_init_cs  !<
+
+    !
+    !-- local variables
+
+    INTEGER :: k
+    !
+    !--    Tendency-terms for chem spcs.
+    tend(:,j,i) = 0.0_wp
+    !    
+    !-- Advection terms
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( ws_scheme_sca )  THEN
+          CALL advec_s_ws( i, j, cs_scalar, 'kc', flux_s_cs, diss_s_cs,                &
+               flux_l_cs, diss_l_cs, i_omp_start, tn )
+       ELSE
+          CALL advec_s_pw( i, j, cs_scalar )
+       ENDIF
+    ELSE
+       CALL advec_s_up( i, j, cs_scalar )
+    ENDIF
+
+    !
+
+    !-- Diffusion terms (the last three arguments are zero)
+
+    CALL diffusion_s( i, j, cs_scalar,                                                 &
+         surf_def_h(0)%cssws(ilsp,:), surf_def_h(1)%cssws(ilsp,:),        &
+         surf_def_h(2)%cssws(ilsp,:),                                     &
+         surf_lsm_h%cssws(ilsp,:), surf_usm_h%cssws(ilsp,:),              &
+         surf_def_v(0)%cssws(ilsp,:), surf_def_v(1)%cssws(ilsp,:),        &
+         surf_def_v(2)%cssws(ilsp,:), surf_def_v(3)%cssws(ilsp,:),        &
+         surf_lsm_v(0)%cssws(ilsp,:), surf_lsm_v(1)%cssws(ilsp,:),        &
+         surf_lsm_v(2)%cssws(ilsp,:), surf_lsm_v(3)%cssws(ilsp,:),        &
+         surf_usm_v(0)%cssws(ilsp,:), surf_usm_v(1)%cssws(ilsp,:),        &
+         surf_usm_v(2)%cssws(ilsp,:), surf_usm_v(3)%cssws(ilsp,:) )
+
+    !    
+    !-- Prognostic equation for chem spcs
+    DO k = nzb+1, nzt
+       cs_scalar_p(k,j,i) = cs_scalar(k,j,i) + ( dt_3d  *                       &
+            ( tsc(2) * tend(k,j,i) +         &
+            tsc(3) * tcs_scalar_m(k,j,i) ) & 
+            - tsc(5) * rdf_sc(k)             &
+            * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
+            )                                                  &
+            * MERGE( 1.0_wp, 0.0_wp,                  &      
+            BTEST( wall_flags_0(k,j,i), 0 )   &             
+            )       
+
+       IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)    !FKS6
+    ENDDO
+
+    !
+    !-- Calculate tendencies for the next Runge-Kutta step
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
+       IF ( intermediate_timestep_count == 1 )  THEN
+          DO  k = nzb+1, nzt
+             tcs_scalar_m(k,j,i) = tend(k,j,i)
+          ENDDO
+       ELSEIF ( intermediate_timestep_count < &
+            intermediate_timestep_count_max )  THEN
+          DO  k = nzb+1, nzt
+             tcs_scalar_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
+                  5.3125_wp * tcs_scalar_m(k,j,i)
+          ENDDO
+       ENDIF
+    ENDIF
+
+ END SUBROUTINE chem_prognostic_equations_ij
+
+ !
+ !------------------------------------------------------------------------------!
+ !
+ ! Description:
+ ! ------------
+ !> Subroutine to read restart data of chemical species
+ !------------------------------------------------------------------------------!
+
+ SUBROUTINE chem_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
+      nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,  &
+      nys_on_file, tmp_3d, found )    
+
+    USE control_parameters
+
+    USE indices
+
+    USE pegrid
+
+    IMPLICIT NONE 
+
+    CHARACTER (LEN=20) :: spc_name_av !<   
+
+    INTEGER(iwp) ::  i, lsp          !< 
+    INTEGER(iwp) ::  k               !< 
+    INTEGER(iwp) ::  nxlc            !< 
+    INTEGER(iwp) ::  nxlf            !< 
+    INTEGER(iwp) ::  nxl_on_file     !<   
+    INTEGER(iwp) ::  nxrc            !< 
+    INTEGER(iwp) ::  nxrf            !< 
+    INTEGER(iwp) ::  nxr_on_file     !<   
+    INTEGER(iwp) ::  nync            !< 
+    INTEGER(iwp) ::  nynf            !< 
+    INTEGER(iwp) ::  nyn_on_file     !<   
+    INTEGER(iwp) ::  nysc            !< 
+    INTEGER(iwp) ::  nysf            !< 
+    INTEGER(iwp) ::  nys_on_file     !<   
+
+    LOGICAL, INTENT(OUT) :: found 
+
+    REAL(wp), DIMENSION(nzb:nzt+1, nys_on_file-nbgp:nyn_on_file+nbgp, nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 3D array to temp store data
+
+
+    found = .FALSE.  
+
+
+    IF ( ALLOCATED(chem_species) )  THEN
+
+       DO lsp = 1, nspec
+
+          !< for time-averaged chemical conc.
+          spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'
+
+          IF ( restart_string(1:length) == TRIM(chem_species(lsp)%name) )    &
+               THEN
+             !< read data into tmp_3d
+             IF ( k == 1 )  READ ( 13 )  tmp_3d  
+             !< fill ..%conc in the restart run    
+             chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                  &
+                  nxlc-nbgp:nxrc+nbgp) =                  & 
+                  tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+             found = .TRUE.
+          ELSEIF (restart_string(1:length) == spc_name_av )  THEN
+             IF ( k == 1 )  READ ( 13 )  tmp_3d
+             chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,               &
+                  nxlc-nbgp:nxrc+nbgp) =               &
+                  tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+             found = .TRUE.
           ENDIF
 
-          DO lsp = 1,nspec
-             tmp_conc(:,lsp) = chem_species(lsp)%conc(nzb+1:nzt,j,i) * tmp_fact(:) 
-          ENDDO
-
-          DO lph = 1,nphot
-             tmp_phot(:,lph) = phot_frequen(lph)%freq(nzb+1:nzt,j,i)               
-          ENDDO
-!
-!--   todo: remove (kanani)
-!           IF(myid == 0 .AND. chem_debug0 ) THEN
-!              IF (i == 10 .and. j == 10) WRITE(0,*) 'begin chemics step ',dt_3d
-!           ENDIF
-
-!--       Compute length of time step
-          IF ( call_chem_at_all_substeps )  THEN
-             dt_chem = dt_3d * weight_pres(intermediate_timestep_count)
-          ELSE
-             dt_chem = dt_3d
-          ENDIF
-
-          cs_time_step = dt_chem
-
-          CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'start' )
-
-          IF(maxval(rcntrl) > 0.0)   THEN    ! Only if rcntrl is set
-             IF( simulated_time <= 2*dt_3d)  THEN
-                 rcntrl_local = 0
-!
-!--   todo: remove (kanani)
-!                  WRITE(9,'(a,2f10.3)') 'USE Default rcntrl in the first steps ',simulated_time,dt_3d
-             ELSE
-                 rcntrl_local = rcntrl
-             ENDIF
-          ELSE
-             rcntrl_local = 0
-          END IF
-
-          CALL chem_gasphase_integrate (dt_chem, tmp_conc, tmp_temp, tmp_qvap, tmp_fact, tmp_phot, &
-                             icntrl_i = icntrl, rcntrl_i = rcntrl_local, xnacc = nacc, xnrej = nrej, istatus=istatus)
-
-          CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'stop' )
-
-          DO lsp = 1,nspec
-             chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)
-          ENDDO
-
-
-       ENDIF
-          CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'stop' )
-
-       RETURN
-    END SUBROUTINE chem_integrate_ij
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining parin for &chemistry_parameters for chemistry model
-!------------------------------------------------------------------------------!
-    SUBROUTINE chem_parin
-   
-       USE chem_modules
-       USE control_parameters
-      
-       USE kinds
-       USE pegrid
-       USE statistics
-           
-       IMPLICIT   NONE
-
-       CHARACTER (LEN=80) ::  line                        !< dummy string that contains the current line of the parameter file
-       CHARACTER (LEN=3)  ::  cs_prefix 
-
-       REAL(wp), DIMENSION(nmaxfixsteps) ::   my_steps    !< List of fixed timesteps   my_step(1) = 0.0 automatic stepping
-       INTEGER(iwp) ::  i                                 !< 
-       INTEGER(iwp) ::  j                                 !< 
-       INTEGER(iwp) ::  max_pr_cs_tmp                     !< 
-
-
-       NAMELIST /chemistry_parameters/  bc_cs_b,                          &
-                                        bc_cs_t,                          &
-                                        call_chem_at_all_substeps,        &
-                                        chem_debug0,                      &
-                                        chem_debug1,                      &
-                                        chem_debug2,                      &
-                                        chem_gasphase_on,                 &
-                                        cs_heights,                       &
-                                        cs_name,                          &
-                                        cs_profile,                       &
-                                        cs_surface,                       &
-                                        decycle_chem_lr,                  &
-                                        decycle_chem_ns,                  &            
-                                        decycle_method,                   &
-                                        do_depo,                          &
-                                        emiss_factor_main,                &
-                                        emiss_factor_side,                &                      
-                                        icntrl,                           &
-                                        main_street_id,                   &
-                                        max_street_id,                    &
-                                        my_steps,                         &
-                                        nest_chemistry,                   &
-                                        rcntrl,                           &
-                                        side_street_id,                   &
-                                        photolysis_scheme,                &
-                                        wall_csflux,                      &
-                                        cs_vertical_gradient,             &
-                                        top_csflux,                       & 
-                                        surface_csflux,                   &
-                                        surface_csflux_name,              &
-                                        cs_surface_initial_change,        &
-                                        cs_vertical_gradient_level,       &
-!                                       namelist parameters for emissions
-                                        mode_emis,                        &
-                                        time_fac_type,                    &
-                                        daytype_mdh,                      &
-                                        do_emis                              
-                             
-!-- analogue to chem_names(nspj) we could invent chem_surfaceflux(nspj) and chem_topflux(nspj)
-!-- so this way we could prescribe a specific flux value for each species
-!>  chemistry_parameters for initial profiles
-!>  cs_names = 'O3', 'NO2', 'NO', ...   to set initial profiles)
-!>  cs_heights(1,:) = 0.0, 100.0, 500.0, 2000.0, .... (height levels where concs will be prescribed for O3)
-!>  cs_heights(2,:) = 0.0, 200.0, 400.0, 1000.0, .... (same for NO2 etc.) 
-!>  cs_profiles(1,:) = 10.0, 20.0, 20.0, 30.0, .....  (chem spcs conc at height lvls chem_heights(1,:)) etc.
-!>  If the respective concentration profile should be constant with height, then use "cs_surface( number of spcs)"
-!>  then write these cs_surface values to chem_species(lsp)%conc_pr_init(:)
-
-!
-!--   Read chem namelist   
-
-       INTEGER             :: ier
-       CHARACTER(LEN=64)   :: text
-       CHARACTER(LEN=8)    :: solver_type
-
-       icntrl    = 0
-       rcntrl    = 0.0_wp
-       my_steps  = 0.0_wp
-       photolysis_scheme = 'simple'
-       atol = 1.0_wp
-       rtol = 0.01_wp
+       ENDDO
+
+    ENDIF
+
+
+ END SUBROUTINE chem_rrd_local
  !
- !--   Try to find chemistry package
-       REWIND ( 11 )
-       line = ' '
-       DO   WHILE ( INDEX( line, '&chemistry_parameters' ) == 0 )
-          READ ( 11, '(A)', END=20 )  line
-       ENDDO
-       BACKSPACE ( 11 )
- !
- !--   Read chemistry namelist
-       READ ( 11, chemistry_parameters, ERR = 10, END = 20 )      
- !
- !--   Enable chemistry model
-       air_chemistry = .TRUE.                    
-       GOTO 20
-
- 10    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'chemistry_parameters', line )
-
- 20    CONTINUE
-
-!
-!--    check for  emission mode for chem species
-       IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT') .AND. (mode_emis /= 'PRE-PROCESSED'  ) )   THEN
-            message_string = 'Incorrect mode_emiss  option select. Please check spelling'
-            CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       t_steps = my_steps          
-                                   
-!--    Determine the number of user-defined profiles and append them to the
-!--    standard data output (data_output_pr)
-       max_pr_cs_tmp = 0 
-       i = 1
-
-       DO  WHILE ( data_output_pr(i)  /= ' '  .AND.  i <= 100 )
-          IF ( TRIM( data_output_pr(i)(1:3)) == 'kc_' ) THEN
-             max_pr_cs_tmp = max_pr_cs_tmp+1
-          ENDIF
-          i = i +1
-       ENDDO
-
-       IF ( max_pr_cs_tmp > 0 ) THEN
-          cs_pr_namelist_found = .TRUE.
-          max_pr_cs = max_pr_cs_tmp
-       ENDIF
-
-!      Set Solver Type
-       IF(icntrl(3) == 0)   THEN
-          solver_type = 'rodas3'           !Default
-       ELSE IF(icntrl(3) == 1)   THEN
-          solver_type = 'ros2'
-       ELSE IF(icntrl(3) == 2)   THEN
-          solver_type = 'ros3'
-       ELSE IF(icntrl(3) == 3)   THEN
-          solver_type = 'ro4'
-       ELSE IF(icntrl(3) == 4)   THEN
-          solver_type = 'rodas3'
-       ELSE IF(icntrl(3) == 5)   THEN
-          solver_type = 'rodas4'
-       ELSE IF(icntrl(3) == 6)   THEN
-          solver_type = 'Rang3'
-       ELSE
-           message_string = 'illegal solver type'
-           CALL message( 'chem_parin', 'PA0506', 1, 2, 0, 6, 0 )
-       END IF
-
-!
-!--   todo: remove or replace by "CALL message" mechanism (kanani)
-!       write(text,*) 'gas_phase chemistry: solver_type = ',trim(solver_type)
-!kk    Has to be changed to right calling sequence
-!kk       CALL location_message( trim(text), .FALSE. )
-!        IF(myid == 0)   THEN
-!           write(9,*) ' '
-!           write(9,*) 'kpp setup '
-!           write(9,*) ' '
-!           write(9,*) '    gas_phase chemistry: solver_type = ',trim(solver_type)
-!           write(9,*) ' '
-!           write(9,*) '    Hstart  = ',rcntrl(3)
-!           write(9,*) '    FacMin  = ',rcntrl(4)
-!           write(9,*) '    FacMax  = ',rcntrl(5)
-!           write(9,*) ' '
-!           IF(vl_dim > 1)    THEN
-!              write(9,*) '    Vector mode                   vektor length = ',vl_dim
-!           ELSE
-!              write(9,*) '    Scalar mode'
-!           ENDIF
-!           write(9,*) ' '
-!        END IF
-
-       RETURN
-
-    END SUBROUTINE chem_parin
-
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine calculating prognostic equations for chemical species 
-!> (vector-optimized).
-!> Routine is called separately for each chemical species over a loop from
-!> prognostic_equations.
-!------------------------------------------------------------------------------!
-    SUBROUTINE chem_prognostic_equations ( cs_scalar_p, cs_scalar, tcs_scalar_m,  &
-                                           pr_init_cs, ilsp )
-
-       USE advec_s_pw_mod,                                                        &
-           ONLY:  advec_s_pw
-       USE advec_s_up_mod,                                                        &
-           ONLY:  advec_s_up
-       USE advec_ws,                                                              &
-           ONLY:  advec_s_ws 
-       USE diffusion_s_mod,                                                       &
-           ONLY:  diffusion_s
-       USE indices,                                                               &
-           ONLY:  nxl, nxr, nyn, nys, wall_flags_0
-       USE pegrid
-       USE surface_mod,                                                           &
-           ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
-                  surf_usm_v
-
-       IMPLICIT NONE
-
-       INTEGER ::  i   !< running index
-       INTEGER ::  j   !< running index
-       INTEGER ::  k   !< running index
-
-       INTEGER(iwp),INTENT(IN) ::  ilsp          !<
-
-       REAL(wp), DIMENSION(0:nz+1) ::  pr_init_cs   !<
-
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar      !<
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar_p    !<
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  tcs_scalar_m   !<
-
-
-   !
-   !-- Tendency terms for chemical species
-       tend = 0.0_wp
-   !    
-   !-- Advection terms
-       IF ( timestep_scheme(1:5) == 'runge' )  THEN
-          IF ( ws_scheme_sca )  THEN
-             CALL advec_s_ws( cs_scalar, 'kc' )
-          ELSE
-             CALL advec_s_pw( cs_scalar )
-          ENDIF
-       ELSE
-            CALL advec_s_up( cs_scalar )
-       ENDIF
-   !
-   !-- Diffusion terms  (the last three arguments are zero)
-       CALL diffusion_s( cs_scalar,                                               &
-                         surf_def_h(0)%cssws(ilsp,:),                             &
-                         surf_def_h(1)%cssws(ilsp,:),                             &
-                         surf_def_h(2)%cssws(ilsp,:),                             &
-                         surf_lsm_h%cssws(ilsp,:),                                &
-                         surf_usm_h%cssws(ilsp,:),                                &
-                         surf_def_v(0)%cssws(ilsp,:),                             &
-                         surf_def_v(1)%cssws(ilsp,:),                             &
-                         surf_def_v(2)%cssws(ilsp,:),                             &
-                         surf_def_v(3)%cssws(ilsp,:),                             &
-                         surf_lsm_v(0)%cssws(ilsp,:),                             &
-                         surf_lsm_v(1)%cssws(ilsp,:),                             &
-                         surf_lsm_v(2)%cssws(ilsp,:),                             &
-                         surf_lsm_v(3)%cssws(ilsp,:),                             &
-                         surf_usm_v(0)%cssws(ilsp,:),                             &
-                         surf_usm_v(1)%cssws(ilsp,:),                             &
-                         surf_usm_v(2)%cssws(ilsp,:),                             &
-                         surf_usm_v(3)%cssws(ilsp,:) )
-   !    
-   !-- Prognostic equation for chemical species
-       DO  i = nxl, nxr
-          DO  j = nys, nyn    
-             DO  k = nzb+1, nzt
-                cs_scalar_p(k,j,i) =   cs_scalar(k,j,i)                           &
-                                     + ( dt_3d  *                                 &
-                                         (   tsc(2) * tend(k,j,i)                 &
-                                           + tsc(3) * tcs_scalar_m(k,j,i)         &
-                                         )                                        & 
-                                       - tsc(5) * rdf_sc(k)                       &
-                                                * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
-                                       )                                          &
-                                       * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )       
-
-                IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)
-             ENDDO
-          ENDDO
-       ENDDO
-   !
-   !-- Calculate tendencies for the next Runge-Kutta step
-       IF ( timestep_scheme(1:5) == 'runge' )  THEN
-          IF ( intermediate_timestep_count == 1 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn   
-                   DO  k = nzb+1, nzt
-                      tcs_scalar_m(k,j,i) = tend(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-             intermediate_timestep_count_max )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb+1, nzt
-                      tcs_scalar_m(k,j,i) = - 9.5625_wp * tend(k,j,i)             &
-                                            + 5.3125_wp * tcs_scalar_m(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       ENDIF
-
-    END SUBROUTINE chem_prognostic_equations
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine calculating prognostic equations for chemical species 
-!> (cache-optimized).
-!> Routine is called separately for each chemical species over a loop from
-!> prognostic_equations.
-!------------------------------------------------------------------------------!
-    SUBROUTINE chem_prognostic_equations_ij ( cs_scalar_p, cs_scalar, tcs_scalar_m, pr_init_cs,    &
-                               i, j, i_omp_start, tn, ilsp, flux_s_cs, diss_s_cs,                  &
-                               flux_l_cs, diss_l_cs )
-       USE pegrid         
-       USE advec_ws,        ONLY:  advec_s_ws 
-       USE advec_s_pw_mod,  ONLY:  advec_s_pw
-       USE advec_s_up_mod,  ONLY:  advec_s_up
-       USE diffusion_s_mod, ONLY:  diffusion_s
-       USE indices,         ONLY:  wall_flags_0
-       USE surface_mod,     ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
-                                   surf_usm_v
-
-
-       IMPLICIT NONE
-
-       REAL(wp), DIMENSION(:,:,:), POINTER   :: cs_scalar_p, cs_scalar, tcs_scalar_m
-
-       INTEGER(iwp),INTENT(IN) :: i, j, i_omp_start, tn, ilsp
-       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: flux_s_cs   !<
-       REAL(wp), DIMENSION(nzb+1:nzt,0:threads_per_task-1)         :: diss_s_cs   !<
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: flux_l_cs   !<
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn,0:threads_per_task-1) :: diss_l_cs   !<
-       REAL(wp), DIMENSION(0:nz+1)                                 :: pr_init_cs  !<
-
-!-- local variables
-
-       INTEGER :: k
-!
-!--    Tendency-terms for chem spcs.
-       tend(:,j,i) = 0.0_wp
-!    
-!-- Advection terms
-       IF ( timestep_scheme(1:5) == 'runge' )  THEN
-          IF ( ws_scheme_sca )  THEN
-             CALL advec_s_ws( i, j, cs_scalar, 'kc', flux_s_cs, diss_s_cs,                &
-                flux_l_cs, diss_l_cs, i_omp_start, tn )
-          ELSE
-             CALL advec_s_pw( i, j, cs_scalar )
-          ENDIF
-       ELSE
-            CALL advec_s_up( i, j, cs_scalar )
-       ENDIF
-
-!
-
-!-- Diffusion terms (the last three arguments are zero)
-
-         CALL diffusion_s( i, j, cs_scalar,                                                 &
-                           surf_def_h(0)%cssws(ilsp,:), surf_def_h(1)%cssws(ilsp,:),        &
-                           surf_def_h(2)%cssws(ilsp,:),                                     &
-                           surf_lsm_h%cssws(ilsp,:), surf_usm_h%cssws(ilsp,:),              &
-                           surf_def_v(0)%cssws(ilsp,:), surf_def_v(1)%cssws(ilsp,:),        &
-                           surf_def_v(2)%cssws(ilsp,:), surf_def_v(3)%cssws(ilsp,:),        &
-                           surf_lsm_v(0)%cssws(ilsp,:), surf_lsm_v(1)%cssws(ilsp,:),        &
-                           surf_lsm_v(2)%cssws(ilsp,:), surf_lsm_v(3)%cssws(ilsp,:),        &
-                           surf_usm_v(0)%cssws(ilsp,:), surf_usm_v(1)%cssws(ilsp,:),        &
-                           surf_usm_v(2)%cssws(ilsp,:), surf_usm_v(3)%cssws(ilsp,:) )
-    
-!    
-!-- Prognostic equation for chem spcs
-       DO k = nzb+1, nzt
-          cs_scalar_p(k,j,i) = cs_scalar(k,j,i) + ( dt_3d  *                       &
-                                                  ( tsc(2) * tend(k,j,i) +         &
-                                                    tsc(3) * tcs_scalar_m(k,j,i) ) & 
-                                                  - tsc(5) * rdf_sc(k)             &
-                                                           * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
-                                                  )                                                  &
-                                                           * MERGE( 1.0_wp, 0.0_wp,                  &      
-                                                                   BTEST( wall_flags_0(k,j,i), 0 )   &             
-                                                                    )       
-
-          IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)    !FKS6
-       ENDDO
-
-!
-!-- Calculate tendencies for the next Runge-Kutta step
-       IF ( timestep_scheme(1:5) == 'runge' )  THEN
-          IF ( intermediate_timestep_count == 1 )  THEN
-             DO  k = nzb+1, nzt
-                tcs_scalar_m(k,j,i) = tend(k,j,i)
-             ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-             intermediate_timestep_count_max )  THEN
-             DO  k = nzb+1, nzt
-                tcs_scalar_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                   5.3125_wp * tcs_scalar_m(k,j,i)
-             ENDDO
-          ENDIF
-       ENDIF
-
-    END SUBROUTINE chem_prognostic_equations_ij
-
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine to read restart data of chemical species
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE chem_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
-                               nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,  &
-                               nys_on_file, tmp_3d, found )    
-                                        
-       USE control_parameters
-               
-       USE indices
-       
-       USE pegrid
-
-       IMPLICIT NONE 
-
-       CHARACTER (LEN=20) :: spc_name_av !<   
-          
-       INTEGER(iwp) ::  i, lsp          !< 
-       INTEGER(iwp) ::  k               !< 
-       INTEGER(iwp) ::  nxlc            !< 
-       INTEGER(iwp) ::  nxlf            !< 
-       INTEGER(iwp) ::  nxl_on_file     !<   
-       INTEGER(iwp) ::  nxrc            !< 
-       INTEGER(iwp) ::  nxrf            !< 
-       INTEGER(iwp) ::  nxr_on_file     !<   
-       INTEGER(iwp) ::  nync            !< 
-       INTEGER(iwp) ::  nynf            !< 
-       INTEGER(iwp) ::  nyn_on_file     !<   
-       INTEGER(iwp) ::  nysc            !< 
-       INTEGER(iwp) ::  nysf            !< 
-       INTEGER(iwp) ::  nys_on_file     !<   
-       
-       LOGICAL, INTENT(OUT)  :: found 
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 3D array to temp store data
-
-
-       found = .FALSE.  
-
-
-          IF ( ALLOCATED(chem_species) )  THEN
-
-             DO  lsp = 1, nspec
-
-                 !< for time-averaged chemical conc.
-                spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'
-
-                IF (restart_string(1:length) == TRIM(chem_species(lsp)%name) )    &
-                THEN
-                   !< read data into tmp_3d
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d  
-                   !< fill ..%conc in the restart run    
-                   chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                  &
-                                          nxlc-nbgp:nxrc+nbgp) =                  & 
-                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                   found = .TRUE.
-                ELSEIF (restart_string(1:length) == spc_name_av )  THEN
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,               &
-                                             nxlc-nbgp:nxrc+nbgp) =               &
-                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                   found = .TRUE.
-                ENDIF
-
-             ENDDO
-
-          ENDIF
-
-
-    END SUBROUTINE chem_rrd_local
-!
-!-------------------------------------------------------------------------------!
-!> Description:
-!> Calculation of horizontally averaged profiles
-!> This routine is called for every statistic region (sr) defined by the user,
-!> but at least for the region "total domain" (sr=0).
-!> quantities.
-!------------------------------------------------------------------------------!
-    SUBROUTINE chem_statistics( mode, sr, tn )
-
-
-       USE arrays_3d
-       USE indices
-       USE kinds
-       USE pegrid
-       USE statistics
+ !-------------------------------------------------------------------------------!
+ !> Description:
+ !> Calculation of horizontally averaged profiles
+ !> This routine is called for every statistic region (sr) defined by the user,
+ !> but at least for the region "total domain" (sr=0).
+ !> quantities.
+ !------------------------------------------------------------------------------!
+ SUBROUTINE chem_statistics( mode, sr, tn )
+
+
+    USE arrays_3d
+    USE indices
+    USE kinds
+    USE pegrid
+    USE statistics
 
     USE user
